package com.sample;

import java.util.ArrayList;
import java.util.List;

import org.jbpm.services.task.lifecycle.listeners.TaskLifeCycleEventListener;

import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.process.WorkflowProcessInstance;
import org.kie.api.task.TaskEvent;
import org.kie.api.task.model.OrganizationalEntity;
import org.kie.api.task.model.Task;
import org.kie.api.task.model.TaskData;
import org.kie.api.task.model.User;
import org.kie.internal.runtime.manager.RuntimeManagerRegistry;
import org.kie.internal.runtime.manager.context.ProcessInstanceIdContext;
import org.kie.internal.task.api.TaskModelProvider;
import org.kie.internal.task.api.model.InternalOrganizationalEntity;
import org.kie.internal.task.api.model.InternalPeopleAssignments;

public class CustomTaskEventListener implements TaskLifeCycleEventListener {

	private RuntimeManagerRegistry registry = RuntimeManagerRegistry.get();

    public CustomTaskEventListener() {
		// TODO Auto-generated constructor stub
	}

    public RuntimeManager getManager(Task task) {           
    	return registry.getManager(task.getTaskData().getDeploymentId());
    }
    
	@Override
	public void beforeTaskActivatedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskClaimedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskSkippedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskStartedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskStoppedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskCompletedEvent(TaskEvent event) {
		// TODO Auto-generated method stub
		Task task = event.getTask();

		long processInstanceId = task.getTaskData().getProcessInstanceId();
		if (processInstanceId <= 0) {
			return;
		}

		RuntimeEngine runtime = getManager(task).getRuntimeEngine(ProcessInstanceIdContext.get(processInstanceId));
		KieSession session = runtime.getKieSession();
		
		TaskData taskdata = task.getTaskData();

		if (session != null) {
			WorkflowProcessInstance instance = (WorkflowProcessInstance)session.getProcessInstance(processInstanceId);
			instance.setVariable("excludedOwnerId", taskdata.getActualOwner().getId());

			System.out.println("[complete] tid: " + task.getId() + ", name: " + task.getNames().get(0).getText() + ", owner: " + taskdata.getActualOwner().getId() + ", status: " + taskdata.getStatus().name());
		}

	}

	@Override
	public void beforeTaskFailedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskAddedEvent(TaskEvent event) {
		// TODO Auto-generated method stub
		Task task = event.getTask();

		long processInstanceId = task.getTaskData().getProcessInstanceId();
		if (processInstanceId <= 0) {
			return;
		}

		RuntimeEngine runtime = getManager(task).getRuntimeEngine(ProcessInstanceIdContext.get(processInstanceId));
		KieSession session = runtime.getKieSession();
		
		if (session != null) {
			WorkflowProcessInstance instance = (WorkflowProcessInstance)session.getProcessInstance(processInstanceId);
			String excludedOwnerId = (String)instance.getVariable("excludedOwnerId");

			if (excludedOwnerId != null) {
				InternalPeopleAssignments peopleAssignments = (InternalPeopleAssignments)task.getPeopleAssignments();

				if (peopleAssignments != null) {
					List<OrganizationalEntity> excludedOwners = new ArrayList<OrganizationalEntity>();
		        	
					User user = TaskModelProvider.getFactory().newUser();
					((InternalOrganizationalEntity)user).setId(excludedOwnerId); 
					excludedOwners.add(user);
		        	
					peopleAssignments.setExcludedOwners(excludedOwners);

					System.out.println("[add] tid: " + task.getId() + ", name: " + task.getNames().get(0).getText() + ", excludedOwner: " + excludedOwnerId + ", status: " + task.getTaskData().getStatus().name());
		        }

			}

		}
	}

	@Override
	public void beforeTaskExitedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskReleasedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskResumedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskSuspendedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskForwardedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void beforeTaskDelegatedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskActivatedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskClaimedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskSkippedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskStartedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskStoppedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskCompletedEvent(TaskEvent event) {
		// TODO Auto-generated method stub
	}

	@Override
	public void afterTaskFailedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskAddedEvent(TaskEvent event) {
		// TODO Auto-generated method stub
	}

	@Override
	public void afterTaskExitedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskReleasedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskResumedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskSuspendedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskForwardedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void afterTaskDelegatedEvent(TaskEvent event) {
		// TODO Auto-generated method stub

	}

}
